/***********************************************************************************/
//
//   { APP-EDF09 OlW PIC16F1937 Xtյ{   	 
//   u@ : MPLAB IDE 8.40								 
//   nu : Hi-Tech PICC Lite v9.70						 
// 	 {ɮ : EDF09_1937.h  		{ƪΫŧiα`Ʃwq
//    			EDF_1937_Main.c   	D{
//  			EDF09_Initialize.c  ]wPIC16F1937P
//   			EDF09_LCD.c			LCD ܨ
//				CSM_N_ISR.c			CSM WvqPɶ_AUART _A䱽yPBzu
//				MCP9800 IIC Function.c		MCP9800-A5 ū׶q	
//				Show_CSM_N_Temperature.c	 CSM WvPūר
//				Show_LCD_Power_On_Test.c    LCD }ɪ
// 				Show_UART_from18F46J50.c  	zL UART  PIC18F46J50 ADC 
//
//  dҵ{ȨѼg{ѦҡAMicrochip ä惡dҵ{tdA]OҸӵ{TL~
//  {~AѫȤ̹ڵ{һݦۦץC
//
//  w~ : IIC  Bus Idle ˬdèS[W Time-Out C
//			   IIC b ACK/NACK ˬdɡAèS[W Time-Out C
//
//  {ʧ@\:
//					1. }ɡAҦP䪺]wAIs LCD ܨư LCD Glass ܴ
//					2. LCD ܴէAܥثeū (: 21.6c),ūתqӦ۪OlW MCP9800-A5 
//					   ݫתqT׬ 0.0625cAܺ׬+-0.1 C
//                  3. U (S4 or S5)YiJ CSM ĲP䪺WvqAĲ Microchip Logo ɡACSM Wv
//				       350KHzAĲN Microchip Logo  CSM WvU100KHzkAŦ⪺ LED8 |GC
//					4. AUA{UARTAzL JP6 & JP7 PIC18F46J50 ҶǰeUART ƨܦbLCDWC
//					   UART Protocal : 19200, N, 8, 1
//					   Data protocal : ": + A + d0 + d1 +...+ 0d +0a	
//					5. AUA VR2 Ҷq쪺qȡA쬰 mVA] 10-bit ADC ҥHѪR׬ 4mV
//					6. AU`ū.....
//					7. _Bz : T4 uBzAT2 for CSM WvqAUART C
//
//    ޳N׾: www.microchip.com.tw 
//   
/***********************************************************************************/

#include <pic.h>
#include <string.h>
#include "EDF09_1937.h"

void Show_ADC_Voltage(void );
void Read_ADC(void);
void Initialize_ADC(void) ;

// ************ ]w PIC16F1937 Configuration Bits  ******
// ]wwqrаѦ pic16f1937.h ɪ
//
__CONFIG  ( FOSC_INTOSC & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & BOREN_ON & CLKOUTEN_ON
		   & IESO_OFF & FCMEN_OFF); 
__CONFIG ( FCMEN_OFF & VCAPEN_OFF & PLLEN_ON & STVREN_OFF & BORV_25 & LVP_OFF);




union		 
{ 	
	unsigned int Word;
	unsigned char Byte[2] ;
}ADC_Result; 
 
extern volatile unsigned char Key_Input;
extern volatile unsigned char Disp_Count;
unsigned char Dig1,D2,D3,D4,D5;
extern unsigned int Temp_Buff;
extern unsigned int Disp_Temp;
		
void main(void)
{
 		OSCCONbits.IRCF=0B1110;		// 8MHz * 4PLL = 32MHz(Fosc)

		Initialize_CPU() ;			// ]w PIC }\

   		Cap_Init();					// ]wqeĲҲաAϥTimer1 & Timer2 ӭpWv
		Init_Timer4();				// ]wTimer4 䱽yγBzu
 		Initialize_I2C_Master();	// ]w Master IIC Ūg MCP9800 ū 
 		Write_MCP9800_Config();		// ]w MCP9800 u@Ҧ
		Initialize_LCD() ;			// ]w LCD u@Ҧ
 		Initialize_UART();			// ]w UART (19200bps)
 		Initialize_ADC( );
			PEIE = 1 ;					// PP䤤_
		GIE = 1;					// P Global _} !!

  		Show_LCD_Test( );

	while(1)
	{
		Show_MCP9800_Temperature( );
		Show_CSM_Frequency( );
  		Show_UART_Receive( );
		Show_ADC_Voltage( );
	}
}


/*
		if (Key_Input==0x01) {
				LED6_On; 
				LED7_Off; 
				Key_Input=0;
			}
		if (Key_Input==0x02) {
				LED6_Off; 
				LED7_On; 
				Key_Input=0;
			}
		if (CSM_Key ==1) LED8_On;
		else LED8_Off;
*/
void Show_ADC_Voltage(void )
{
	Key_Input=0;				// M䪬AL
	Disp_Count = 40;			// ]wC 200mS  VR q@ 
	LED8_Off;
	Clear_LCD( );

	do	
	{
		if (Disp_Count==0)		// 100mS F? {|C 200mS s LCD W VR2 q@
		{
	 		Read_ADC();								// Ū ADC (VR2) ഫ
			Temp_Buff= ADC_Result.Word & 0x3FF;		// NLΦ줸B\ 0
			Disp_Temp=(((unsigned long)Temp_Buff)*489)/10; 	// 10-bit ѪRסA1 LSB=4.89mV
	  												// Xڹqè 0.1mV
			Dig1 = 0;
	
			Dig1=Disp_Temp/10000;					// ഫ V
  			DisplayDigit1(Dig1);					//  V LCD Ĥ@ƦrW
			Disp_Temp=Disp_Temp%10000;				// Xl
				
 			DisplayDigit2(Disp_Temp/1000 );			//  100mV	
			Disp_Temp=Disp_Temp%1000;				 
	
			DisplayDigit3(Disp_Temp/100);			//  10mV
			Disp_Temp=Disp_Temp%100;
	
			DisplayDigit4(Disp_Temp/10);			//  mV
			Disp_Temp=Disp_Temp%10;
	
			DisplayDigit5(Disp_Temp);				//  0.1mV
	
		 	SEG_4DP=1 ;								// IpI
	
  			SEG_m=1;								//  mV Ÿ
			SEG_V=1;
			SEG_BAT=!SEG_BAT;

			Disp_Count = 40;						// ]wC 200mS ܹq@ 
		} 
	}while (Key_Input ==0);			// j餺ˬdO_sU? YLh~ܹq
									//YhXܹq
//	LED6_Off;
}									

void Read_ADC(void)
{
	GO_nDONE = 1 ;
	while (GO_nDONE) ;
	ADC_Result.Byte[0] = ADRESL ;  // Get 10-bit ADC Result
	ADC_Result.Byte[1] = ADRESH ;
}

void Initialize_ADC(void)
{
	TRISB2 = 1; 			// Set RB2 as Input pin
	ANSB2 = 1; 				// Set RB2/AN8 as Analog input function pin
	ADCON0 = 0b00100001;  	// ADC Enable, Select AN8 for VR2 input (RB2/AN8)
	ADCON1 = 0b11110000;  	// Right Justified, Internal FRC, Vref- to Vss, Vref+ to Vdd
	ADIF = 0;
}


 

