
void Initialize_I2C_Master(void);
void Read_Temperature(void);
void Write_MCP9800_Config(void);
void IdleI2C( void );
void StartI2C( void );
unsigned char WriteI2C( unsigned char );
unsigned char ReadI2C( void );
void AckI2C( void );
void NotAckI2C( void );
void RestartI2C( void );
void StopI2C( void );
void I2C_Done(void);


 
#define 	SCL 	RC3			// 	I2C pin
#define		SDA		RC4
#define		SCL_DIR	TRISC3
#define		SDA_DIR	TRISC4

#define		MCP9800_Addr_Read	0b10011011   	// A5 Address + Read Function
#define		MCP9800_Addr_Write	0b10011010		// A% Address + Write Function
#define		MCP9800_Point_Temp	0b00000000		// MCP9800 ū׼ȦsЦ}
#define		MCP9800_Point_Conf  0b00000001		// MCP9800 tmȦsЦ}
#define		MCP9800_Point_Hyst	0b00000010		
#define		MCP9800_Point_Limit	0b00000011		 
