
#include <pic.h>
#include "EDF09_1937.h"

 
volatile union
{ 	
	unsigned int Full_Timer ;
	unsigned char Timer_Byte[2] ;
}CSM;	// wqqePqWv

unsigned int CSM_BUF[16];  			// 16Ӱ}Csq쪺WvȡA[`A16Wv

volatile unsigned char CSM_Flag = 0;
volatile unsigned char W_Index = 0;
volatile unsigned char Bounce_Count=0;
volatile unsigned char Key_Input=0;				// SW5 & SW6 䪺
volatile unsigned char CSM_Key=0;
volatile unsigned int CSM_ever_Freq_Temp = 600;	//WvȪȦs
volatile unsigned char Disp_Count =0;

volatile int REC_Index = 0 ;
volatile unsigned char	REC_Temp ;
unsigned char REC_Buffer[20];

volatile bit REC_A_LINE=0 ;			// @檺Xks


//********************************************************************
// ISR()  
// In the Timer2 ISR :  C 1mS _ŪTimer1 pƭȨæs}C
// ץ}CСAγ]wCSM_Flag XqD{nBz CSM 
//********************************************************************

void interrupt isr(void) 
{
	if (TMR2IE && TMR2IF)					// Is the Timer2 interrupt ?						
	{
		TMR2IF=0;							// Clear T2IF every time
 		TMR1ON	= 0;						// Ȯ Timer1 p
		CSM.Timer_Byte[0]= TMR1L;			// UTimer1 ȡA LSB A MSB
		CSM.Timer_Byte[1]= TMR1H;
		CSM_BUF[W_Index++] = CSM.Full_Timer;// N 16-bit  Timer1 Ȧs}C

 		TMR1H	= 0;						// reset Timer1
 		TMR1L	= 0;						//   "     "
 		TMR1ON	= 1;						// sҰ Timer1 p CSM \
 		if (W_Index == 16) W_Index =0;
		CSM_Flag = 1;
	}

	//********************************************************************
	// Timer4 C 5mS _@AΨӰ䱽yΫuBz
	// Pw CSM WvO_C 300KHz 
	//********************************************************************
	if (TMR4IE && TMR4IF)					// Is the Timer4 interrupt ?
	{
		TMR4IF=0;
		
		if (Disp_Count) Disp_Count--;		// Delay Count - 1

		if (Bounce_Count==0)				// uBzq?
		{									// uBzwgAy
			if (!SW5)						// SW5 QU( Low) ?
			{
				Bounce_Count=8; 			// OA]wsˬd 8 uɶ(40mS)
				Key_Input= 0x01;			// ]w SW5@ȥѥD{Bz
//				LED6=!LED6;
			}  
 			if (!SW6)						// SW6 QU( Low) ?
			{
				Bounce_Count=8; 
				Key_Input= 0x02;
//				LED6=!LED6;
			}  
			if (CSM_ever_Freq_Temp <= 300) CSM_Key = 0x01;  // CSMWvC 300KHzɪܦĲN
			else CSM_Key = 0;				// CSM Wvj 300KHzAL
		}  
		else								// iJuBzq
		{
			if ( !SW5 || !SW6) Bounce_Count=8;	// ˬd SW5  SW6 O_}F,Sܭ]uˬd
			else Bounce_Count--;			// p}Auˬdƴ@
		}
	}
	if (RCIF)
	{
		REC_Temp = RCREG ;		//	Read RCREG and save it to REC_Temp
		TXREG= REC_Temp;

		if (REC_Temp == 0x0d)	//	0x0d = end of a line 
		{	
			REC_Buffer[REC_Index] = 0x00 ;
			REC_Index = 0 ;

		// --------------------------------------------------------
		// M 0x0d , YĤ@ӦrD ':' 
		// ܦriण
		// ҥH⦳ı ...................
		// --------------------------------------------------------
			if (REC_Buffer[0] == ':' ) 	REC_A_LINE = 1 ;
		 }
			else if ( REC_Temp > 0x20 && REC_Temp < 0x80 )	// ȱiѦr
				REC_Buffer[REC_Index++] = REC_Temp ;			
	}

}
